/*

Note: I have never coded any Windows-Stuff before, neither do I know
much about Miranda-ICQ plugins, so this code may be crap.
Yeah, I know, it's a real mess.. :P
Feel free to improve it.

Currently, langpack-feature is not supported yet. Will maybe use it
in further versions, if anybody finds it useful.

Warning: Currently, using this program is a security leak, as everybody
can change your ICQ-status by connecting to the socket and sending
a Shutdown-signal.
TODO: Do an authentification first (via ICQ UIN/PW from DB)

Currently, the BNC only bounces Messages. URLs and even FILEs-Support
isn't built in yet. Maybe I will add it in future versions.

It would also be useful if LastSeen-Time would be synchronised.

kinda History: v 0.0.0.2 - Changes:
			   * Bug with pending Messages on server, which were already
			     processed on client was fixed (blinking msgs.)
			   * Popup-Support was implemented
			   * Reconnect-Status is transmitted to BNC-client
			   * Code now a bit more fail-safe and cleaner
			   * Removed faulty ping-pong and made a persistant winsock-connection
			     instead, so if the connection breaks, this may indicate that
				 the server has to reconnect.
			   * Fixed a few threading bugs (return instead of _endthread())
			   v 0.0.0.3 - Changes:
			   * Eliminated a few globals
			   * Added debugging stuff
			   * Changes IP-Adress Textfields to IP-Fields in options dialog
			   * Fixed bug with Server reconnect plugin crashing when you 
			     don't change ICQ status mode after startup.
			   * Added support for optionally changing status & away-msg of ICQbnc-
				 server when client goes offline.
	(NOTE: use miranda_sys_free() to free variable allocated on miranda's heap)
			   v 0.0.0.4 - Changes:
			   * Implemented Time synchronisation option
			   * Redesigned options dialog a bit
			   * Implemented history synchronisation
			   * Reduced amount of data required for sending pending msgs
			   * Sending pending msgs is now a seperate command.
			     This is needed, because synchronizing history already sends
				 pending MSGs.
			   * Included AggressiveOptimize.h for better optimisation of resulting 
			     .DLL size
	(NOTE: use Project/Settings/Settings for: Win32 Release/"C/C++"/Cytegory: Code Generation/
		   Runtime Library/Multithreaded DLL to optimize Plugin size!)
			   v 0.0.0.5 - Changes:
			   * Now messages and URLs are synced on history-Synchronisation or 
			     exchange of unread messages.
			   * Now history is really synchronized, so that events from the
			     client, that are missing on the server are also synchronized

Known bugs:
 * ICQbnc Client crashes if Connection to server is lost and client is shut down
 * Changing from Server to Client mode and vice versa often causes a lockup
  
There is no warranty.

*/

#include <windows.h>
#include <process.h>
#include "resource.h"
#include <stdio.h>
#include <commctrl.h>
#include "AggressiveOptimize.h"

#include "../../headers_c/newpluginapi.h"
#include "../../headers_c/m_clist.h"
#include "../../headers_c/m_skin.h"
#include "../../headers_c/m_database.h"
#include "../../headers_c/m_options.h"
#include "../../headers_c/m_protocols.h"
#include "../../headers_c/m_protosvc.h"
#include "../../headers_c/m_awaymsg.h"
#include "../../headers_c/m_system.h"


#pragma comment(lib, "ws2_32")

#define DELAY 5000		// Delay between disconnection on server and reconnection on client and
						// vice versa. Needed for the ICQ-Server, because he kicks our ass,
						// if we login/logoff too quickly.
#define USEPOPUP 1		// Use the popup-plugin?

#ifdef USEPOPUP
  #include "../popup/api/m_popup.h"
#endif
#ifdef _DEBUG
//  #define DEBUG_OUT(a) ShowMessage(IDI_BNCOK, a, 0);
  #define DEBUG_OUT(a) MessageBox(NULL,a,pluginInfo.shortName, MB_OK | MB_ICONWARNING);
#else
  #define DEBUG_OUT(a)
#endif

static BOOL CALLBACK ServerAwayDlgProc(HWND, UINT, WPARAM, LPARAM);
static BOOL CALLBACK SyncDlgProc(HWND, UINT, WPARAM, LPARAM);

HINSTANCE hInst;
HANDLE hOptHook, hStatusHookServer, hStatusHookClient;
PLUGINLINK *pluginLink;
SOCKET ListenSocket;

PLUGININFO pluginInfo={
	sizeof(PLUGININFO),
	"ICQbnc",
	PLUGIN_MAKE_VERSION(0,0,0,5),
	"This Plugin enables Miranda to act like a 'bouncer' to stay always online. (see readme.txt for details)",
	"dose",
	"leecher@dose.0wnz.at",
	" 2004 dose",
	"http://miranda-icq.sourceforge.net/",
	0,		//not transient
	0		//doesn't replace anything built-in
};

struct ServerStatusData {
	int statusMode;
	char *msg;
};

/*
 * Global variables:
 *
 * StayOffline	-	Indicate, if I should stay offline until client tells 
 *					me to reconnect? (required for alwaysOnline) -> ReconnectTimer
 * running		-	ServerThread running? [1/0]
 * ServerHost	-	Hostname/IP of the icqBNC-Server where the client connects to
 * ServerPort	-	Port of the icqBNC-Server where the client connects to
 * iStatus		-	ICQ online-Status user has changed to last time 
 *					-> ReconnectTimer, ServerStatusModeChange
 * ClientSocket	-	Socket on which the Client communicates with the server
 * doReconnect	-	If reconnect=1 and connection was lost, this flag indicates, 
 *					if the server should reconnect after Tolerance time has passed
 *					without a reconnection from the client
 */

BYTE StayOffline=0, ReconnectTimer_run, doReconnect=0;
SOCKET ClientSocket=INVALID_SOCKET;
volatile int running;
char ServerHost[255], BindIP[16];
unsigned short ServerPort;
unsigned int iStatus=0, mirandaStatus=ID_STATUS_NA;

/******************************* MAIN PROCEDURES *****************************/


// -- Helper funtioncs -- //

// (DIRTY HACK?): Copied from sendrecv/awaymsg/sendmsg.c
static char *StatusModeToDbSetting(int status,const char *suffix)
{
    char *prefix;
	static char str[64];

	switch(status) {
		case ID_STATUS_AWAY: prefix="Away";	break;
		case ID_STATUS_NA: prefix="Na";	break;
		case ID_STATUS_DND: prefix="Dnd"; break;
		case ID_STATUS_OCCUPIED: prefix="Occupied"; break;
		case ID_STATUS_FREECHAT: prefix="FreeChat"; break;
		case ID_STATUS_ONLINE: prefix="On"; break;
		case ID_STATUS_OFFLINE: prefix="Off"; break;
		case ID_STATUS_INVISIBLE: prefix="Inv"; break;
		case ID_STATUS_ONTHEPHONE: prefix="Otp"; break;
		case ID_STATUS_OUTTOLUNCH: prefix="Otl"; break;
		default: return NULL;
	}
	lstrcpy(str,prefix); lstrcat(str,suffix);
	return str;
}

/*
 * ShowMessage
 *
 * Shows a popup, if the popup plugin is enabled.
 * mustShow: 1 -> If Popup-Plugin is not available/disabled, show Message
 *                in a Messagewindow
 *                If the Popup-Plugin is enabled, let the message stay on
 *                screen until someone clicks it away.
 *           0 -> If Popup-Plugin is not available/disabled, skip message
 * Returns 0 on success, -1 on failure
 *
 */
int ShowMessage(int iconID, char *lpzText, int mustShow) {
    POPUPDATAEX pud;

#ifdef USEPOPUP
    if ((BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "ShowNonCriticalPopups", 1)==0) return -1;
	pud.lchContact = (HANDLE)NULL;
    pud.lchIcon = LoadIcon(hInst, MAKEINTRESOURCE(iconID));
    strncpy(pud.lpzContactName, pluginInfo.shortName, MAX_CONTACTNAME);
    strncpy(pud.lpzText, lpzText, MAX_SECONDLINE);
    pud.colorBack = 0;
    pud.colorText = 0;
    pud.PluginWindowProc = (WNDPROC)NULL;
    pud.PluginData = NULL;
	pud.iSeconds = mustShow==1?-1:0;
	pud.lpzClass = mustShow==1?POPUP_CLASS_WARNING:POPUP_CLASS_DEFAULT;
	pud.skinBack = 0;
    if (PUAddPopUpEx(&pud)<0) {
		if (mustShow==1) MessageBox(NULL,lpzText,pluginInfo.shortName, MB_OK | MB_ICONWARNING);
		return -1;
	}
	if (mustShow==1) MessageBeep(-1);
	return 0;
#else
	if (mustShow==1) MessageBox(NULL,lpzText,pluginInfo.shortName, MB_OK | MB_ICONWARNING);
	return -1;
#endif
}


/*
     0 Success
	-1 Socket Error
	-2 Memory allocation error
	-3 Event with Zero timestamp received
*/
int GetEvent(SOCKET ReceiveSocket, HANDLE hContact) {
	DBEVENTINFO dbei={0};
	int length;
	char *msg;

	dbei.cbSize=sizeof(dbei);
	if ((recv(ReceiveSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR)) return -1;
	if (dbei.timestamp==0) return -3;	
	if (recv(ReceiveSocket, (char *)&dbei.flags, sizeof(dbei.flags), 0)==SOCKET_ERROR ||
		recv(ReceiveSocket, (char *)&dbei.eventType, sizeof(dbei.eventType), 0) == SOCKET_ERROR ||
		recv(ReceiveSocket, (char *)&length, sizeof(length), 0)==SOCKET_ERROR) return -1;
	if ((msg=(char*)malloc(length+1))==NULL) return -2;
	if (recv(ReceiveSocket, msg, length, 0)==SOCKET_ERROR) {
		free (msg);
		return -1;
	}
	msg[length]=0;
	dbei.szModule=(char*)CallService(MS_PROTO_GETCONTACTBASEPROTO,(WPARAM)hContact,0);
	dbei.cbBlob=lstrlen(msg)+1;
	dbei.pBlob=(PBYTE)msg;
	CallService(MS_DB_EVENT_ADD,(WPARAM)hContact,(LPARAM)&dbei);
	free(msg);
	return 0;
}



/*
 * SendEvents
 *
 * Does the Events Synchronisation loop for the given contact up to the given
 * timestamp.
 * 
 * Returns >=0 number of events sent on success
 *		  -1 on socket error
 *		  -2 on memory allocation error
 */
int SendEvents(SOCKET SendSocket, HANDLE hContact, DWORD timestamp) {
	DBEVENTINFO dbei={0};
	HANDLE hDbEvent;
	int length, numEvents=0;
	char *szText;

	hDbEvent=(HANDLE)CallService(MS_DB_EVENT_FINDLAST,(WPARAM)hContact,0);
	dbei.cbSize=sizeof(dbei);
	while(hDbEvent) {
		dbei.cbBlob=CallService(MS_DB_EVENT_GETBLOBSIZE,(WPARAM)hDbEvent,0);
		if ((szText=(char*)malloc(dbei.cbBlob+1))==NULL) return -2;
		dbei.pBlob=szText;
		CallService(MS_DB_EVENT_GET,(WPARAM)hDbEvent,(LPARAM)&dbei);
		if (dbei.timestamp<=timestamp) break;
		// NOTE: In my opinion, events other than Message and URL are not useful to sync
		if(dbei.eventType==EVENTTYPE_MESSAGE || dbei.eventType==EVENTTYPE_URL) {
			length=strlen(szText);
			if ((send(SendSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR) || //DWORD
				(send(SendSocket, (char *)&dbei.flags, sizeof(dbei.flags), 0)==SOCKET_ERROR) ||  // DWORD
				(send(SendSocket, (char *)&dbei.eventType, sizeof(dbei.eventType), 0) == SOCKET_ERROR) ||
				(send(SendSocket, (char *)&length, sizeof(length), 0)==SOCKET_ERROR) || // INT
				(send(SendSocket, szText, length, 0)==SOCKET_ERROR)) {
				free(szText);
				return -1;
			}
			if (!(dbei.flags&(DBEF_SENT|DBEF_READ))) {
				CallService(MS_DB_EVENT_MARKREAD,(WPARAM)hContact,(LPARAM)hDbEvent);
				CallService(MS_CLIST_REMOVEEVENT,(WPARAM)hContact,(LPARAM)hDbEvent);
			}
			numEvents++;
		}
		free(szText);
		hDbEvent=(HANDLE)CallService(MS_DB_EVENT_FINDPREV,(WPARAM)hDbEvent,0);
	}
	dbei.timestamp=0;
	if (send(SendSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR) return -1;
	return numEvents;
}

/*
 * ReceiveEvents
 *
 * Does the Events Synchronisation loop for the given contact using the
 * timestamp in the supplied DB-Eventinfo.
 * 
 * Returns >=0 Number of events received on success
 *		  -1 on socket error
 *		  -2 on memory allocation error
 */
int ReceiveEvents(SOCKET ReceiveSocket, HANDLE hContact, DBEVENTINFO dbei) {

	int stat, numEvents=0;

	if (send(ReceiveSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR) return -1;
	while ((stat=GetEvent(ReceiveSocket, hContact))==0) numEvents++;
	if (stat==-1 || stat==-2) return stat; else  return numEvents;
}

/*
 * SendUnreadMessages
 *
 * Sends unread messages from the Server via the socket SendSocket
 * to the client, which can receive them via ReceiveUnreadMessages(SOCKET)
 *
 * Format of the messages via our socket:
 * [UIN]
 *		[timestamp][length of message][message]
 *
 * UIN and timestamp are DWORDs, length is an int, so until the message
 * the length of data is always fixed and therefore no field seperators are
 * needed.
 *
 * Returns 0 on success
 *		  -1 on socket error
 *		  -2 on memory allocation error
 */
int SendUnreadMessages(SOCKET SendSocket) {
	DBEVENTINFO dbei={0};
	HANDLE hDbEvent,hContact;
	DWORD dwUIN;
	char *szText;
	int length;

	dbei.cbSize=sizeof(dbei);
	hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
	while(hContact) {
		hDbEvent=(HANDLE)CallService(MS_DB_EVENT_FINDFIRSTUNREAD,(WPARAM)hContact,0);
        dwUIN = DBGetContactSettingDword(hContact, "ICQ", "UIN", 0);
		if ( (send(SendSocket, (char *)&dwUIN, sizeof(dwUIN), 0)==SOCKET_ERROR)) return -1;
		while(hDbEvent) {
			dbei.cbBlob=CallService(MS_DB_EVENT_GETBLOBSIZE,(WPARAM)hDbEvent,0);
			if ((szText=(char*)malloc(dbei.cbBlob+1))==NULL) return -2;
			dbei.pBlob=szText;
			CallService(MS_DB_EVENT_GET,(WPARAM)hDbEvent,(LPARAM)&dbei);
			// NOTE: In my opinion, events other than Message and URL are not useful to sync
			if(!(dbei.flags&(DBEF_SENT|DBEF_READ)) && 
				(dbei.eventType==EVENTTYPE_MESSAGE || dbei.eventType==EVENTTYPE_URL)) {
				length=strlen(szText);
				if ( (send(SendSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR) || //DWORD
					 (send(SendSocket, (char *)&dbei.eventType, sizeof(dbei.eventType), 0)==SOCKET_ERROR) || // WORD
					 (send(SendSocket, (char *)&length, sizeof(length), 0)==SOCKET_ERROR) || // INT
					 (send(SendSocket, szText, length, 0)==SOCKET_ERROR)) {
					free(szText);
					return -1;
				}
				CallService(MS_DB_EVENT_MARKREAD,(WPARAM)hContact,(LPARAM)hDbEvent);
				CallService(MS_CLIST_REMOVEEVENT,(WPARAM)hContact,(LPARAM)hDbEvent);
			}
			free(szText);
			hDbEvent=(HANDLE)CallService(MS_DB_EVENT_FINDNEXT,(WPARAM)hDbEvent,0);
		}
		dbei.timestamp=0;
		if (send(SendSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR) return -1;
		hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
	}
	dwUIN=0;
	if (send(SendSocket, (char *)&dwUIN, sizeof(dwUIN), 0)==SOCKET_ERROR) return -1;	// It's the end my friend
	return 0;
}

/*
 * ReceiveUnreadMessages
 *
 * Receives unread messages (if there are any) from the Server via the socket 
 * ReceiveSocket, who sends them via SendUnreadMessages(SOCKET), and places
 * them in the event queue, so that they are shown like normal incoming
 * messages from the apropriate user
 *
 * Returns 0 on success
 *		  -1 on socket error
 *		  -2 on memory allocation error
 */
int ReceiveUnreadMessages(SOCKET ReceiveSocket) {
	DBEVENTINFO dbei={0};
	DWORD dwUIN, UIN;
	HANDLE hContact;
    int length;
	char *msg;

	ShowMessage(IDI_BNCOK, "Receiving unread Messages from BNC-Server", 0);
	while(1) {
		// Receive message
		if (recv(ReceiveSocket, (char *)&UIN, sizeof(UIN), 0)==SOCKET_ERROR) return -1;
		if (!UIN) break;
		while (1) {
			if ((recv(ReceiveSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR)) return -1;
			if (!dbei.timestamp) break;
			if  (recv(ReceiveSocket, (char *)&dbei.eventType, sizeof(dbei.eventType), 0)==SOCKET_ERROR ||
				 recv(ReceiveSocket, (char *)&length, sizeof(length), 0)==SOCKET_ERROR) return -1;
			if ((msg=(char*)malloc(length+1))==NULL) return -2;
			if (recv(ReceiveSocket, msg, length, 0)==SOCKET_ERROR) {
				free (msg);
				return -1;
			}
			msg[length]=0;
			// Find contact matching UIN and send msg
			hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
			while(hContact) {
				dwUIN = DBGetContactSettingDword(hContact, "ICQ", "UIN", 0);
				if (dwUIN==UIN) {
					dbei.cbSize=sizeof(dbei);
					dbei.eventType=EVENTTYPE_MESSAGE;
					dbei.flags=0;
					dbei.szModule=(char*)CallService(MS_PROTO_GETCONTACTBASEPROTO,(WPARAM)hContact,0);
					dbei.cbBlob=lstrlen(msg)+1;
					dbei.pBlob=(PBYTE)msg;
					CallService(MS_DB_EVENT_ADD,(WPARAM)hContact,(LPARAM)&dbei);
					break;
				}
				hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
			}
			free(msg);
		}
	}
	return 0;
}


/*
 * SendMissingHistory
 *
 * Synchronizes History with the ICQbnc-Server via the SendSocket
 * This includes eventually pending messages, so this function replaces
 * SendUnreadMessages, if history synchronisation is needed.
 * 
 * Protocol:
 * Client                Server
 * -----------------------------------
 * CMD [7]    -->
 *
 * UIN        -->        			<-+
 * Timestamp  -->					  |
 *            <--		[0..n] Events |
 *[			  <--		Timestamp    ]| ] only, if
 *[ Events    -->					 ]| ] #Events=0
 *        - loop until UIN=0 -     ---+
 *
 * Returns 0 on success
 *		  -1 on socket error
 *		  -2 on memory allocation error
 *		  -4 general error
 */
int SendMissingHistory(SOCKET SendSocket) {
	DBEVENTINFO dbei={0};
	HANDLE hContact, hDbEvent;
	DWORD dwUIN, timestamp;
	int errcode=0;

	while (1) {
		if (recv(SendSocket, (char *)&dwUIN, sizeof(dwUIN), 0)==SOCKET_ERROR) return -1;
		if (!dwUIN) break;
		if (recv(SendSocket, (char *)&timestamp, sizeof(timestamp), 0)==SOCKET_ERROR) return -1;

		hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
		while(hContact) {
			if (DBGetContactSettingDword(hContact, "ICQ", "UIN", 0)==dwUIN) break;
			hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
		}
		if (hContact) {
			if ((errcode=SendEvents(SendSocket, hContact, timestamp))<0) return errcode;
			if (errcode==0) { // No events to send -> Maybe sync the other way round
				dbei.cbSize=sizeof(dbei);
				dbei.cbBlob=0;
				if ((hDbEvent=(HANDLE)CallService(MS_DB_EVENT_FINDLAST,(WPARAM)hContact,0))) {
					if (CallService(MS_DB_EVENT_GET,(WPARAM)hDbEvent,(LPARAM)&dbei)) {
						dbei.timestamp=0;
						if (send(SendSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR) return -1;
						return -4;
					}
				} else {
					dbei.timestamp=1;
				}
				if ((errcode=ReceiveEvents(SendSocket, hContact, dbei))<0) return errcode;
			}
		} else {
			timestamp=0;
			if (send(SendSocket, (char *)&timestamp, sizeof(timestamp), 0)==SOCKET_ERROR) return -1;
		}
	}
	return 0;
}


/*
 * ReceiveMissingHistory
 *
 * Synchronizes History with the ICQbnc-Server via the ReceiveSocket
 * This includes eventually pending messages, so this function replaces
 * ReceiveUnreadMessages, if history synchronisation is needed.
 * 
 * Returns 0 on success
 *		  -1 on socket error
 *		  -2 on memory allocation error
 *		  -3 Dialog creation error
 *		  -4 General error
 */
int ReceiveMissingHistory(SOCKET ReceiveSocket) {
	DBEVENTINFO dbei={0};
	HANDLE hDbEvent,hContact;
	HWND hSyncDlg;

	DWORD dwUIN, timestamp;
	char format[64], str[128];
	int errcode=0;

	if (DBGetContactSettingDword(NULL, pluginInfo.shortName, "HistorySyncMode", IDC_DONTSYNCHIST)==IDC_DONTSYNCHIST) return -4;
	dbei.cbSize=sizeof(dbei);
	if (!(hSyncDlg=CreateDialog(hInst,MAKEINTRESOURCE(IDD_SYNCDLG),NULL,SyncDlgProc))) return -3;
	GetDlgItemText(hSyncDlg,IDC_SYNCTXT,format, sizeof(format));
	SendDlgItemMessage(hSyncDlg,IDC_PROGRESS1,PBM_SETRANGE,(WPARAM)0,MAKELPARAM(0, CallService(MS_DB_CONTACT_GETCOUNT,0,0)));
	hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
	while(hContact) {
		char *szProto;

		// Display progress
		_snprintf(str,sizeof(str),format,(char*)CallService(MS_CLIST_GETCONTACTDISPLAYNAME, (WPARAM)hContact, 0));
		SetDlgItemText(hSyncDlg,IDC_SYNCTXT,str);
		SendDlgItemMessage(hSyncDlg,IDC_PROGRESS1,PBM_STEPIT,0,0);
		UpdateWindow(hSyncDlg);
		if (!(szProto=(char*)CallService(MS_PROTO_GETCONTACTBASEPROTO,(WPARAM)hContact,0)) || strcmp(szProto, "ICQ") || 
		DBGetContactSettingDword(NULL, pluginInfo.shortName, "HistorySyncMode", IDC_DONTSYNCHIST)==IDC_SYNCONLINECONTACTS && 
		DBGetContactSettingWord(hContact,"ICQ","Status",ID_STATUS_OFFLINE)==ID_STATUS_OFFLINE) {
			hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
			continue;
		}
		// Send stuff
		if ((hDbEvent=(HANDLE)CallService(MS_DB_EVENT_FINDLAST,(WPARAM)hContact,0))) {
			dwUIN = DBGetContactSettingDword(hContact, "ICQ", "UIN", 0);
			dbei.cbBlob=0;
			if (CallService(MS_DB_EVENT_GET,(WPARAM)hDbEvent,(LPARAM)&dbei)) {
				errcode=-4;
				break;
			}
			if (send(ReceiveSocket, (char *)&dwUIN, sizeof(dwUIN), 0)==SOCKET_ERROR) {
				errcode=-1;
				break;
			}
			if ((errcode=ReceiveEvents(ReceiveSocket, hContact, dbei))<0) break;
			if (errcode==0) {	// No events were received, so try the other way round
				if (recv(ReceiveSocket, (char *)&timestamp, sizeof(timestamp), 0)==SOCKET_ERROR) return -1;
				if (timestamp!=0) 
					if ((errcode=SendEvents(ReceiveSocket, hContact, timestamp))<0) return errcode;
			}
			errcode=0;
		}
		hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
	}
	DestroyWindow(hSyncDlg);
	if (errcode!=0) return errcode;
	dwUIN=0;
	if (send(ReceiveSocket, (char *)&dwUIN, sizeof(dwUIN), 0)==SOCKET_ERROR) return -1;	// It's the end my friend
	return 0;
}


/*
 * SendMissingHistoryOfPending
 *
 * Synchronizes History with the ICQbnc-Server via the SendSocket
 * This includes eventually pending messages, so this function replaces
 * SendUnreadMessages, if history synchronisation is needed.
 * In difference to SendMissingHistory, this function uses a slightly
 * different protocol, so that the ICQbnc Server tells us which contacts
 * to sync. In this case: The contacts of the users where messages are pending.
 * 
 * Protocol:
 *
 * Client                Server
 * -----------------------------------
 * CMD [8]    -->
 *			  <--		#Contacts
 *            <--		UIN 		<-+    <----------+
 * Timestamp  -->					  | Timestamp=0 --+
 *            <--		[0..n] Events |
 *        - loop until UIN=0 -     ---+
 *
 * Returns 0 on success
 *		  -1 on socket error
 *		  -2 on memory allocation error
 *		  -4 General error
 */
int SendMissingHistoryOfPending(SOCKET SendSocket) {
	DBEVENTINFO dbei={0};
	HANDLE hDbEvent,hContact;
	DWORD dwUIN, timestamp;
	unsigned int iContacts=0;
	int errcode=0;

	hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
	while(hContact) {
		if ((HANDLE)CallService(MS_DB_EVENT_FINDFIRSTUNREAD,(WPARAM)hContact,0)) iContacts++;
		hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
	}
	if (send(SendSocket, (char *)&iContacts, sizeof(iContacts), 0)==SOCKET_ERROR) return -1;
	if (iContacts==0) return 0; // No contacts on list.
	hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
	while(hContact) {
		if ((HANDLE)CallService(MS_DB_EVENT_FINDFIRSTUNREAD,(WPARAM)hContact,0)) {
			hDbEvent=(HANDLE)CallService(MS_DB_EVENT_FINDLAST,(WPARAM)hContact,0);
			dwUIN=DBGetContactSettingDword(hContact, "ICQ", "UIN", 0);
			if (send(SendSocket, (char *)&dwUIN, sizeof(dwUIN), 0)==SOCKET_ERROR ||
				recv(SendSocket, (char *)&timestamp, sizeof(timestamp), 0)==SOCKET_ERROR)
				return -1;
			if (!timestamp) {
				hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
				continue;
			}
			if ((errcode=SendEvents(SendSocket, hContact, timestamp))<0) return errcode;
			if (errcode==0) { // No events to send -> Maybe sync the other way round
				dbei.cbSize=sizeof(dbei);
				dbei.cbBlob=0;
				if ((hDbEvent=(HANDLE)CallService(MS_DB_EVENT_FINDLAST,(WPARAM)hContact,0))) {
					if (CallService(MS_DB_EVENT_GET,(WPARAM)hDbEvent,(LPARAM)&dbei)) {
						dbei.timestamp=0;
						if (send(SendSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR) return -1;
						return -4;
					}
				} else {
					dbei.timestamp=1;
				}
				if ((errcode=ReceiveEvents(SendSocket, hContact, dbei))<0) return errcode;
			}
		}
		hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
	}
	dwUIN=0;
	if (send(SendSocket, (char *)&dwUIN, sizeof(dwUIN), 0)==SOCKET_ERROR) return -1;
	return 0;
}


/*
 * ReceiveMissingHistoryOfPending
 *
 * Synchronizes History with the ICQbnc-Server via the ReceiveSocket
 * This includes eventually pending messages, so this function replaces
 * ReceiveUnreadMessages, if history synchronisation is needed.
 * In difference to ReceiveMissingHistory, this function uses a slightly
 * different protocol, so that the ICQbnc Server tells us which contacts
 * to sync. In this case: The contacts of the users where messages are pending.
 * 
 * Returns 0 on success
 *		  -1 on socket error
 *		  -2 on memory allocation error
 *		  -3 Dialog creation error
 *		  -4 General error
 */
int ReceiveMissingHistoryOfPending(SOCKET ReceiveSocket) {
	DBEVENTINFO dbei={0};
	HANDLE hDbEvent,hContact;
	HWND hSyncDlg;

	DWORD dwUIN=0;
	char format[64], str[128];
	int errcode=0;
	unsigned int iContacts=0;

	if (DBGetContactSettingDword(NULL, pluginInfo.shortName, "HistorySyncMode", IDC_DONTSYNCHIST)!=IDC_SYNCPENDINGCONTACTS) return -4;
	dbei.cbSize=sizeof(dbei);
	if (!(hSyncDlg=CreateDialog(hInst,MAKEINTRESOURCE(IDD_SYNCDLG),NULL,SyncDlgProc))) return -3;
	GetDlgItemText(hSyncDlg,IDC_SYNCTXT,format, sizeof(format));
	if (recv(ReceiveSocket, (char *)&iContacts, sizeof(iContacts), 0)==SOCKET_ERROR) {
		DestroyWindow(hSyncDlg);
		return -1;
	}
	if (iContacts==0) {	// No contacts on server's list
		DestroyWindow(hSyncDlg);
		return 0;
	}
	SendDlgItemMessage(hSyncDlg,IDC_PROGRESS1,PBM_SETRANGE,(WPARAM)0,MAKELPARAM(0, iContacts));
	while (1) {
		if (recv(ReceiveSocket, (char *)&dwUIN, sizeof(dwUIN), 0)==SOCKET_ERROR) {
			errcode=-1;
			break;
		}
		if (dwUIN==0) break;
		hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST,0,0);
		while(hContact) {
			if (DBGetContactSettingDword(hContact, "ICQ", "UIN", 0)==dwUIN) break;
			hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDNEXT,(WPARAM)hContact,0);
		}
		if (hContact) {
			// Display progress
			_snprintf(str,sizeof(str),format,(char*)CallService(MS_CLIST_GETCONTACTDISPLAYNAME, (WPARAM)hContact, 0));
			SetDlgItemText(hSyncDlg,IDC_SYNCTXT,str);
			SendDlgItemMessage(hSyncDlg,IDC_PROGRESS1,PBM_STEPIT,0,0);
			UpdateWindow(hSyncDlg);
			dbei.cbBlob=0;
			if (!(hDbEvent=(HANDLE)CallService(MS_DB_EVENT_FINDLAST,(WPARAM)hContact,0)))
				dbei.timestamp=1;
			else {
				if (CallService(MS_DB_EVENT_GET,(WPARAM)hDbEvent,(LPARAM)&dbei)) {
					errcode=-4;
					break;
				}
			}
			if ((errcode=ReceiveEvents(ReceiveSocket, hContact, dbei))<0) break;
			errcode=0;
		} else {	// Contact not found locally
			dbei.timestamp=0;
			if (send(ReceiveSocket, (char *)&dbei.timestamp, sizeof(dbei.timestamp), 0)==SOCKET_ERROR) {
				errcode=-1;
				break;
			}
		}
		SendDlgItemMessage(hSyncDlg,IDC_PROGRESS1,PBM_STEPIT,0,0);
	}
	DestroyWindow(hSyncDlg);
	return errcode;
}


/*
 * CreateAwayMsgDlg
 *
 * Shows away message Dialog for changing Server's away-Message.
 * It works like the normal away-dialog, but also has a dropdown-list
 * with the Status mode of the Server.
 *
 * Returns	 0 - success
 *			-1 - General error (Data Xchange failed)
 *			-2 - Memory allocation error
 *			-3 - Socket error
 */
int CreateAwayMsgDlg(void) {
	int ServerStatus=0, length;
    struct ServerStatusData *ssdat;

	// Give the user the opportunity to change the away-msg of the server before reconnecting the server
	if (send (ClientSocket, "3", 1, 0)==SOCKET_ERROR ||
		recv(ClientSocket, (char *)&ServerStatus, sizeof(ServerStatus), 0)==SOCKET_ERROR)
		return -3;
	if (ServerStatus) {
		if (recv(ClientSocket, (char *)&length, sizeof(length), 0)==SOCKET_ERROR) return -3;
		if ((ssdat = (struct ServerStatusData*)malloc(sizeof(struct ServerStatusData)))==NULL) return -2;
		if (length) {
			if ((ssdat->msg=(char*)malloc(length+1))==NULL) {
				free(ssdat);
				return -2;
			}
			ZeroMemory(ssdat->msg, length+1);
			if (recv(ClientSocket, ssdat->msg, length, 0)==SOCKET_ERROR) {
				free(ssdat->msg);
				free(ssdat);
				return -3;
			}
			ssdat->statusMode = ServerStatus;
			if (DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_SERVERAWAY),NULL,ServerAwayDlgProc,(LPARAM)ssdat)<0) {
				free(ssdat->msg);
				free(ssdat);
				return -1;
			}
		}
		return 0;
	}
	return -1;
}

/*
 * SynchronizeTime
 *
 * Synchronizes the clock of this client with the ICQbnc server
 *
 * Returns	 1 - No need to sync
 *			 0 - Synced
 *			-1 - Socket error
 */
int SynchronizeTime(void) {
	  SYSTEMTIME lpSystemTime, lpServerTime;

	  if (send(ClientSocket, "5", 1, 0)==SOCKET_ERROR ||
		  recv(ClientSocket, (char *)&lpServerTime, sizeof(lpServerTime), 0)==SOCKET_ERROR)
		  return -1;
	  GetSystemTime(&lpSystemTime);
	  if (lpSystemTime.wYear   != lpServerTime.wYear   || 
		  lpSystemTime.wMonth  != lpServerTime.wMonth  ||
		  lpSystemTime.wDay    != lpServerTime.wDay    ||
		  lpSystemTime.wHour   != lpServerTime.wHour   ||
		  lpSystemTime.wMinute != lpServerTime.wMinute) {
		    SetSystemTime(&lpServerTime);
		    return 0;
	  }
	  return 1;
}

/*
 * ShutdownClientSocket
 *
 * Closes client socket 
 */
void ShutdownClientSocket(void) {
	if (ClientSocket==INVALID_SOCKET) return;
	if (closesocket(ClientSocket)==SOCKET_ERROR) 
		ShowMessage(IDI_BNCERROR, "Closing ClientSocket failed.", 1);
	else
		ClientSocket=INVALID_SOCKET;
}

/*
 * Reconnect
 *
 * Reconnects the ICQ-client in the previous status (before he was turned offline by
 * a client request) using the old status message without asking for it.
 *
 * Requires global variable mirandaStatus for old status.
 */
void Reconnect(unsigned int mStatus) {
	BYTE bUsePrev, bNoDlg;

	if (mStatus==ID_STATUS_OFFLINE) mStatus=ID_STATUS_NA;
	bUsePrev=DBGetContactSettingByte(NULL,"SRAway",StatusModeToDbSetting(mStatus,"UsePrev"),0);
	bNoDlg=DBGetContactSettingByte(NULL,"SRAway",StatusModeToDbSetting(mStatus,"NoDlg"),0);
	DBWriteContactSettingByte(NULL,"SRAway",StatusModeToDbSetting(mStatus,"UsePrev"),1);
	DBWriteContactSettingByte(NULL,"SRAway",StatusModeToDbSetting(mStatus,"NoDlg"),1);
	//CallProtoService("ICQ", PS_SETSTATUS, (WPARAM)mStatus, 0);
	CallService(MS_CLIST_SETSTATUSMODE,mStatus,0);	// Restore old Status (Go online)
	DBWriteContactSettingByte(NULL,"SRAway",StatusModeToDbSetting(mStatus,"UsePrev"),bUsePrev);
	DBWriteContactSettingByte(NULL,"SRAway",StatusModeToDbSetting(mStatus,"NoDlg"),bNoDlg);
	ShowMessage(IDI_BNCOK, "Reconnecting to my previous online-status", 0);
}

/*
 * ReconnectTimer
 *
 * If this plugin is configured as a server and the "Reconnect Server on
 * unintended disconnection" option is activated, this thread periodically checks,
 * if the server got disconnected without being told to do so.
 * Should this be the case, it immediately reconnects in the old status.
 */
void ReconnectTimer(void *dummy) {
	ReconnectTimer_run=1;
	
	while (ReconnectTimer_run) {
		Sleep((unsigned int)DBGetContactSettingDword(NULL, pluginInfo.shortName, "AlwaysOnlineInterval", 60000));
		if (!StayOffline && iStatus!=ID_STATUS_OFFLINE && CallProtoService("ICQ", PS_GETSTATUS,0,0)==ID_STATUS_OFFLINE)
			Reconnect(iStatus);
	}
	_endthread();
}

/*
 * ReconnectCountdown
 *
 * Counts down ReconnectTolerance seconds before it reconnects the BNC-Server, if the
 * connection to the client was lost.
 */
void ReconnectCountdown(void *dummy) {
	doReconnect=1;

	Sleep((unsigned int)DBGetContactSettingDword(NULL, pluginInfo.shortName, "ReconnectTolerance", 30000));
	if (doReconnect) {
		Reconnect(mirandaStatus);
		StayOffline=0;
	}
	_endthread();
}

/*
 * WaitForReconnect
 *
 * Waits until the ICQ protocol has reconnected successfully or not
 * Params:	 szProto - Name of the Protocol which has to be checked, i.E. ICQ
 *			 timeout - When after timout ms the reconnection wasn't successful,
 *					   return error -1
 * Returns:  0 - on success
 *			-1 - on timeout error
 *			-2 - on reconnect unsuccessful
 */
int WaitForReconnect(char *szProto, int timeout) {
	int stat, c=0;

	do {
		if (c*100>=timeout) return -1;
		Sleep(100);
		c++;
		stat=CallProtoService(szProto, PS_GETSTATUS,0,0);
	} while (stat>=ID_STATUS_CONNECTING && stat<ID_STATUS_CONNECTING+MAX_CONNECT_RETRIES);
	if (stat==ID_STATUS_OFFLINE) return -2; else return 0;
}



// -- Server & Client main functions -- //


/*
 * ServerThread
 *
 * This thread is running, if the plugin is configured as a server.
 * It waits for an incoming connection on BindIP:BindPort (global variables)
 * and reacts to the client's commands.
 * For the commands see below.
 *
 */
void ServerThread(void *dummy) {
  char sendbuf, recvbuf, *msg;
  int sstat, length, err, reuse_option=1;
  SYSTEMTIME lpSystemTime;
  BYTE bUsePrev;
  HANDLE hContact;

  SOCKADDR_IN service;
  SOCKET AcceptSocket;
  
  running=1;
  ListenSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
  if (ListenSocket == INVALID_SOCKET) {
	ShowMessage(IDI_BNCERROR,"ServerThread: Error at socket()", 1);
	running=-1;
    _endthread();
  }

  service.sin_family = AF_INET;
  service.sin_addr.s_addr = inet_addr(BindIP);
  service.sin_port = htons((unsigned short)DBGetContactSettingWord(NULL, pluginInfo.shortName, "BindPort", 1398));
  if (setsockopt( ListenSocket, SOL_SOCKET, SO_REUSEADDR, (char *)&reuse_option, sizeof(reuse_option))<0)
    ShowMessage(IDI_BNCERROR, "ServerThread: (non-critical) cannot set socket options.", 1);

  if (bind( ListenSocket, (SOCKADDR*) &service, sizeof(service)) == SOCKET_ERROR) {
	ShowMessage(IDI_BNCERROR, "ServerThread: bind() to interface failed.", 1);
    closesocket(ListenSocket);
	running=-1;
    _endthread();
  }

  if (listen( ListenSocket, 1 ) == SOCKET_ERROR) {
	ShowMessage(IDI_BNCERROR, "ServerThread: Error listening on socket.",1);
    closesocket(ListenSocket);
	running=-1;
    _endthread();
  }

 
  while(1) {	// Main loop
	AcceptSocket = SOCKET_ERROR;
    while( AcceptSocket == SOCKET_ERROR && running )
      AcceptSocket = accept( ListenSocket, NULL, NULL );
	doReconnect=0;
	if (!running) break; // If thread was cancelled, bail out

	while(1) {	// Receive loop
		recvbuf=0;
		sstat=recv(AcceptSocket, &recvbuf, 1, 0);
		if (!sstat || sstat==SOCKET_ERROR) {
			if ((BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "Reconnect", 0) && doReconnect==0 && 
				CallProtoService("ICQ", PS_GETSTATUS, 0, 0)==ID_STATUS_OFFLINE)
				_beginthread(ReconnectCountdown, 0, NULL);
			ShowMessage(IDI_BNCERROR, "Connection to my client was lost.", 0);
			break;
		}

		switch (recvbuf) {
			case '1':					// Command: Bye bye...
				if (CallProtoService("ICQ", PS_GETSTATUS, 0, 0)!=ID_STATUS_OFFLINE) {
					StayOffline=1;
					mirandaStatus=CallProtoService("ICQ", PS_GETSTATUS, 0, 0);  // Remember old status
					
					// This would be global status, but we only want ICQ
					CallService(MS_CLIST_SETSTATUSMODE,ID_STATUS_OFFLINE,0);	// Go Offline
					//CallProtoService("ICQ", PS_SETSTATUS, (WPARAM)ID_STATUS_OFFLINE, 0);
					Sleep(DELAY); // Wait n seconds before giving client OK to reconnect so that there is time for
								  // the ICQ Server (otherwise it will give you an error and blocks login for 20 Minutes!)
				}
				send(AcceptSocket, "0", 1, 0);
				break;
			case '2':					// Command: Reconnect...
				sendbuf='0';
				if (CallProtoService("ICQ", PS_GETSTATUS, 0, 0)==ID_STATUS_OFFLINE) {
					ShowMessage(IDI_BNCOK, "Client signed off...", 0);
					Sleep(DELAY); // Wait n seconds before reconnecting so that there is time for the ICQ-server
								  //(otherwise it will give you an error and blocks login for 20 Minutes!)
					Reconnect(mirandaStatus);
					StayOffline=0;
					if (WaitForReconnect("ICQ", 30000)<0) sendbuf='E';
				}
				send(AcceptSocket, &sendbuf, 1, 0);
				break;
			case '3':					// Command: Get current StatusMsg
				length=0;
				if (send(AcceptSocket, (char*)&mirandaStatus, sizeof(mirandaStatus), 0)==SOCKET_ERROR) {
					ShowMessage(IDI_BNCERROR, "Socket error while sending ICQ Status to BNC-client", 1);
					break;
				}
				bUsePrev=DBGetContactSettingByte(NULL,"SRAway",StatusModeToDbSetting(mirandaStatus,"UsePrev"),0);
				if (!bUsePrev) DBWriteContactSettingByte(NULL,"SRAway",StatusModeToDbSetting(mirandaStatus,"UsePrev"),1);
				msg = (char*)CallService(MS_AWAYMSG_GETSTATUSMSG, (WPARAM)mirandaStatus, 0);
				if (!bUsePrev) DBWriteContactSettingByte(NULL,"SRAway",StatusModeToDbSetting(mirandaStatus,"UsePrev"),bUsePrev);
				if (msg) {
					length=strlen(msg);
					if (send(AcceptSocket, (char *)&length, sizeof(length), 0)==SOCKET_ERROR ||
						send(AcceptSocket, msg, length, 0) == SOCKET_ERROR) {
						miranda_sys_free(msg);
						break;
					}
					miranda_sys_free(msg);
				} else send(AcceptSocket, (char *)&length, sizeof(length), 0);
				break;
			case '4':					// Command: Set current reconn. Status + Msg
				if (recv(AcceptSocket, (char *)&mirandaStatus, sizeof(mirandaStatus), 0)==SOCKET_ERROR ||
					recv(AcceptSocket, (char *)&length, sizeof(length), 0)==SOCKET_ERROR) {
					ShowMessage(IDI_BNCERROR, "Socket error while receiving reconn. Status and message from BNC-client", 1);
					break;
				}
				if (length>0) {
					ShowMessage(IDI_BNCOK, "Client changes status message", 0);
					if (!(msg=(char *)malloc(length+1))) {
						ShowMessage(IDI_BNCERROR, "StatusMessageChange: Memory allocation failure", 1);
						break;
					}
					if (recv(AcceptSocket, msg, length, 0)==SOCKET_ERROR) {
						free(msg);
						break;
					}
					msg[length]=0;
					CallProtoService("ICQ",PS_SETAWAYMSG,mirandaStatus,(LPARAM)msg);
					DBWriteContactSettingString(NULL,"SRAway",StatusModeToDbSetting(mirandaStatus,"Msg"),msg);
					free(msg);
				}
				break;
			case '5':					// Command: Get current time
				GetSystemTime(&lpSystemTime);
				send(AcceptSocket, (char *)&lpSystemTime, sizeof(lpSystemTime), 0);
				break;
			case '6':					// Command: Send all pending messages
				switch (SendUnreadMessages(AcceptSocket)) {	// Now you may reconnect and fetch your msgs
					case 0:  ShowMessage(IDI_BNCOK, "Sent all pending messages to BNC-client", 0); break;
					case -1: ShowMessage(IDI_BNCERROR, "Socket error while sending messages to BNC-client", 1); break;
					case -2: ShowMessage(IDI_BNCERROR, "Memory allocation error while sending messages to BNC-client", 1); break;
				}		
				break;
			case '7':					// Command: Send all requested history events
				switch(SendMissingHistory(AcceptSocket)) {
					case 0:  ShowMessage(IDI_BNCOK, "Sent all history events", 0); break;
					case -1: ShowMessage(IDI_BNCERROR, "Socket error while sending history to BNC-client", 1); break;
					case -2: ShowMessage(IDI_BNCERROR, "Memory allocation error while sending history to BNC-client", 1); break;
				}		
				break;
			case '8':					// Command: Synchronize contacts where msgs are pending
				switch(SendMissingHistoryOfPending(AcceptSocket)) {
					case 0:  ShowMessage(IDI_BNCOK, "Sent all history events", 0); break;
					case -1: ShowMessage(IDI_BNCERROR, "Socket error while sending history to BNC-client", 1); break;
					case -2: ShowMessage(IDI_BNCERROR, "Memory allocation error while sending history to BNC-client", 1); break;
				}		
				break;
			case '9':					// Command: Add sent event 
				if (recv(AcceptSocket, (char *)&hContact, sizeof(hContact), 0)==SOCKET_ERROR) err=-1;
				else err=GetEvent(AcceptSocket, hContact);
				switch (err) {
					case -1: ShowMessage(IDI_BNCERROR, "Socket error while adding event from BNC-client", 1); break;
					case -2: ShowMessage(IDI_BNCERROR, "Memory allocation error while adding event from BNC-client", 1); break;
				}
				break;
		}
	}
  }
  running=-1;
  _endthread();
}

/*
 * ServerStatusModeChange
 *
 * If this plugin is configured as a server and the "Reconnect Server on
 * unintended disconnection" option is activated, this callback function
 * is being called on status mode change, when the user changes its status
 * manually. The global variable iStatus is set to prevent the reconnection
 * thread to reconnect, if the user changed to offline status himself.
 */
int ServerStatusModeChange(WPARAM wParam,LPARAM lParam) {
	iStatus=wParam;
	return 0;
}

/*
 * StatusModeChange
 *
 * If this plugin is configured as a client, this callback-Function is called
 * everytime the ICQ-status is changed.
 * This function checks, if th client changed from offline to online or from
 * online to offline and gives the appropriate command to the ICQbnc-Server
 * to go either online or offline
 * When the client goes online, it gives the server the command to go offline
 * and fetches all pending messages.
 * When the client goes offline, it gives the server the command to go back
 * into its previous state.
 *
 */
int StatusModeChange(WPARAM wParam,LPARAM lParam)
{
  char command='2', recvbuf='0';
  unsigned int myStatus=CallProtoService("ICQ", PS_GETSTATUS, 0, 0);

  SOCKADDR_IN service;
  fd_set fd;
  TIMEVAL tv;
  tv.tv_sec = 0;
  tv.tv_usec = 0;
  FD_ZERO (&fd);
  FD_SET (ClientSocket, &fd);

  if (!*ServerHost || (lParam && strcmp((char *)lParam, "ICQ"))) return 0;
  if (wParam==ID_STATUS_OFFLINE) {
		command='2';						// Going offline
  } else {
	if (myStatus==ID_STATUS_OFFLINE || myStatus==ID_STATUS_CONNECTING)
		command='1';	 					// Going online
    else return 0;
  }

  if (select(1, NULL, &fd, NULL, &tv)==SOCKET_ERROR || ClientSocket==INVALID_SOCKET) {
	ShowMessage(IDI_BNCOK, "Connecting to ICQbnc Server", 0);
	ClientSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (ClientSocket == INVALID_SOCKET) {
		ShowMessage(IDI_BNCERROR,"StatusModeChange: Error creating socket" , 1);
	    return 0;
	}

	if ((service.sin_addr.s_addr = inet_addr(ServerHost)) == -1)
	{
		struct hostent *hp;

		if (hp=gethostbyname(ServerHost))
			memcpy(&service.sin_addr.s_addr, hp->h_addr, sizeof(long));
		else
		{
			ShowMessage (IDI_BNCERROR, "StatusModeChange: Cannot resolve host", 1);
			return 0;
		}
	}

	service.sin_family = AF_INET;
	service.sin_port = htons(ServerPort);

	if ( connect( ClientSocket, (SOCKADDR*) &service, sizeof(service) ) == SOCKET_ERROR) {
	  ShowMessage(IDI_BNCERROR, "StatusModeChange: Failed to connect to server", 1);
	  return 0;
	}
  }

  if (command=='1') {
	if (send( ClientSocket, &command, 1, 0 )==SOCKET_ERROR ||
	    recv(ClientSocket, &recvbuf, 1, 0)==SOCKET_ERROR) return 0;
	if ((BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "SyncTime", 1))
	  switch (SynchronizeTime()) {
		case  1: ShowMessage(IDI_BNCOK, "No need to sync clock with ICQbnc server",0); break;
		case  0: ShowMessage(IDI_BNCOK, "Synchronized clock with ICQbnc server",0); break;
		case -1: ShowMessage(IDI_BNCERROR, "SynchronizeTime(): Socket error",1); ClientSocket=INVALID_SOCKET; return 0;
	  }
    ShowMessage(IDI_BNCOK, "Bouncing...", 0);
    switch (DBGetContactSettingDword(NULL, pluginInfo.shortName, "HistorySyncMode", IDC_DONTSYNCHIST)) {
      case IDC_DONTSYNCHIST:
		if (send(ClientSocket, "6", 1, 0)==SOCKET_ERROR) return 0;
		switch (ReceiveUnreadMessages(ClientSocket)) {
			case  0: ShowMessage(IDI_BNCOK, "Received all pending messages from BNC-server.", 0); break;
			case -1: ShowMessage(IDI_BNCERROR, "Socket error while receiving messages from BNC-server", 1); ClientSocket=INVALID_SOCKET; return 0;
			case -2: ShowMessage(IDI_BNCERROR, "Memory allocation error while receiving messages from BNC-server", 1); return 0;
		}
		break;
	  case IDC_SYNCALLCONTACTS:
	  case IDC_SYNCONLINECONTACTS:
		if (send(ClientSocket, "7", 1, 0)==SOCKET_ERROR) return 0;
		switch(ReceiveMissingHistory(ClientSocket)) {
			case  0: ShowMessage(IDI_BNCOK, "Successfully synchronized history", 0); break;
			case -1: ShowMessage(IDI_BNCERROR, "ReceiveMissingHistory(): Socket error", 1); ClientSocket=INVALID_SOCKET; return 0;
			case -2: ShowMessage(IDI_BNCERROR, "ReceiveMissingHistory(): Memory allocation error", 1); return 0;
			case -3: ShowMessage(IDI_BNCERROR, "ReceiveMissingHistory(): Error creating dialog", 1); return 0;
			case -4: ShowMessage(IDI_BNCERROR, "ReceiveMissingHistory(): General error", 1); return 0;
		}
		break;
 	  case IDC_SYNCPENDINGCONTACTS:
		if (send(ClientSocket, "8", 1, 0)==SOCKET_ERROR) return 0;
		switch(ReceiveMissingHistoryOfPending(ClientSocket)) {
			case  0: ShowMessage(IDI_BNCOK, "Successfully synchronized history", 0); break;
			case -1: ShowMessage(IDI_BNCERROR, "ReceiveMissingHistoryOfPending(): Socket error", 1); ClientSocket=INVALID_SOCKET; return 0;
			case -2: ShowMessage(IDI_BNCERROR, "ReceiveMissingHistoryOfPending(): Memory allocation error", 1); return 0;
			case -3: ShowMessage(IDI_BNCERROR, "ReceiveMissingHistoryOfPending(): Error creating dialog", 1); return 0;
			case -4: ShowMessage(IDI_BNCERROR, "ReceiveMissingHistoryOfPending(): General error", 1); return 0;
		}		
		break;
	}
  }
  if (command=='2') {
	  if ((BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "ChangeServerAwayMsg", 0))
		  switch (CreateAwayMsgDlg()) {
			case  0: ShowMessage(IDI_BNCOK, "Successfully changed servers away-status", 0); break;
			case -1: ShowMessage(IDI_BNCERROR, "Failed to create awaymsg-Dialog", 1); break;
			case -2: ShowMessage(IDI_BNCERROR, "CreateAwayMsgDlg(): Memory allocation failure", 1); break;
			case -3: ShowMessage(IDI_BNCERROR, "CreateAwayMsgDlg(): Socket error", 1); ClientSocket=INVALID_SOCKET; return 0;
		  }
	  if (send( ClientSocket, &command, 1, 0 )==SOCKET_ERROR ||
	  recv(ClientSocket, &recvbuf, 1, 0)==SOCKET_ERROR) return 0;
	  if (recvbuf=='0')
		ShowMessage(IDI_BNCOK, "Reconnection successful.", 0);
	  else {
		ShowMessage(IDI_BNCERROR, "Reconnection failed on server-side! You may try again.", 1);
		ShutdownClientSocket();
		return 0;
	  }
  }
  return 0;
}




/******************************* INSTALLATION PROCEDURES *****************************/

/* AlwaysOnlineCtl
 *
 * Controls the AlwaysOnline thread
 * Parameters: stat: 0 - Shutdown AlwaysOnline thread
 *					 1 - Fire up AlwaysOnline thread
 * Returns:	   0 - on success
 *			  -1 - on failure
 */
int AlwaysOnlineCtl(int stat) {
	if (stat) {
		if (ReconnectTimer_run==0) {
			if (iStatus==0) iStatus=CallProtoService("ICQ", PS_GETSTATUS, 0, 0);
			hStatusHookServer = HookEvent(ME_CLIST_STATUSMODECHANGE,ServerStatusModeChange);
			_beginthread(ReconnectTimer, 0, NULL);
			return 0;
		} else return -1;
	} else {
		if (ReconnectTimer_run==1) {
			UnhookEvent(hStatusHookServer);
			ReconnectTimer_run=0;
			return 0;
		} else return -1;
	}
}

/*
 * LoadServer
 *
 * Initializes all necessary stuff if this ICQbnc is configured as a server
 */
void LoadServer(void) {
	_beginthread(ServerThread, 0, NULL);
	if ((BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "AlwaysOnline", 0)) 
		if (AlwaysOnlineCtl(1)==-1) ShowMessage(IDI_BNCERROR, "Cannot start AlwaysOnline watch-thread as it's already running. OOOPS, you may have found a bug.", 1);
}

/*
 * LoadClient
 *
 * Initializes all necessary stuff if this ICQbnc is configured as a client
 */
void LoadClient(void) {
	hStatusHookClient = HookEvent(ME_CLIST_STATUSMODECHANGE,StatusModeChange);
}

/*
 * UnloadServer
 *
 * Removes all resources allocated if this ICQbnc is configured as a server
 */
void UnloadServer(void) {
	running=0;
    if (closesocket(ListenSocket)==SOCKET_ERROR) 
  	  ShowMessage(IDI_BNCERROR, "Closing ListenSocket failed.", 1);
	else
	  ListenSocket=INVALID_SOCKET;
	while (running!=-1) Sleep(100);	// Wait for server process to finish (maybe replace by mutex in future)
	if ((BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "AlwaysOnline", 0)) AlwaysOnlineCtl(0);
}

/*
 * UnloadClient
 *
 * Removes all resources allocated if this ICQbnc is configured as a client
 */
void UnloadClient(void) {
	ShutdownClientSocket();
	UnhookEvent(hStatusHookClient);
}

// Dialog Procedure handlers 


static BOOL CALLBACK SyncDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam)
{

	switch(message) {
		case WM_INITDIALOG:
			SendDlgItemMessage(hwndDlg,IDC_PROGRESS1,PBM_SETSTEP,(WPARAM)1, 0);
			return TRUE;
			break;
	}
	return 0;
}

/*
 * ServerAwayDlgProc
 *
 * This callback function is called, when the Dialog for changing the status
 * and away message from the server is shown.
 * The function contains all necessary stuff to process the fields in the dialog.
 * This function is invoked by the dialog created in procedure CreateAwayMsgDlg
 */

static BOOL CALLBACK ServerAwayDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
	char str[1024], format[128];
	static int countdown=5;
	int i, j;
	struct ServerStatusData *ssdat = (struct ServerStatusData*)lParam;
	const int statusModes[]={ID_STATUS_ONLINE,ID_STATUS_AWAY,ID_STATUS_NA,ID_STATUS_OCCUPIED,ID_STATUS_DND,ID_STATUS_FREECHAT,ID_STATUS_INVISIBLE};

	switch(message) {
		case WM_INITDIALOG:
			SendDlgItemMessage(hwndDlg,IDC_MSG,EM_LIMITTEXT,1024,0);
			GetWindowText(hwndDlg, format, sizeof(format));
			_snprintf(str,sizeof(str),format,(char*)CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,ssdat->statusMode,0));
			SetWindowText(hwndDlg,str);
			for(i=0;i<sizeof(statusModes)/sizeof(statusModes[0]);i++) {
				j=SendDlgItemMessage(hwndDlg,IDC_STATUS,CB_ADDSTRING,0,(LPARAM)CallService(MS_CLIST_GETSTATUSMODEDESCRIPTION,statusModes[i],0));
				SendDlgItemMessage(hwndDlg,IDC_STATUS,CB_SETITEMDATA,j,statusModes[i]);
				if (ssdat->statusMode == statusModes[i]) SendDlgItemMessage(hwndDlg,IDC_STATUS,CB_SETCURSEL,i,0);
			}
			SetDlgItemText(hwndDlg,IDC_MSG,ssdat->msg);
			free(ssdat->msg);
			free(ssdat);
			countdown=5;
			SendMessage(hwndDlg,WM_TIMER,0,0);
			SetTimer(hwndDlg,1,1000,0);
			return TRUE;
		case WM_TIMER:
			if(countdown==-1) {DestroyWindow(hwndDlg); break;}
			ZeroMemory(&str, sizeof(str));
			_snprintf(str,sizeof(str),"Closing in %d seconds",countdown);
			SetDlgItemText(hwndDlg,IDOK,str);
			countdown--;
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					DestroyWindow(hwndDlg);
					break;
				case IDC_STATUS:
					if ((i=(SendDlgItemMessage(hwndDlg, IDC_STATUS, CB_GETITEMDATA, SendDlgItemMessage(hwndDlg,IDC_STATUS,CB_GETCURSEL,0,0), 0)))==ID_STATUS_ONLINE ||
						i==ID_STATUS_INVISIBLE)
						EnableWindow(GetDlgItem(hwndDlg, IDC_MSG), FALSE);
				    else
						EnableWindow(GetDlgItem(hwndDlg, IDC_MSG), TRUE);
					break;
				case IDC_MSG:
					KillTimer(hwndDlg,1);
					SetDlgItemText(hwndDlg,IDOK,"OK");
					break;
			}
			break;
		case WM_DESTROY:
			GetDlgItemText(hwndDlg,IDC_MSG,str,sizeof(str));
			i=SendDlgItemMessage(hwndDlg, IDC_STATUS, CB_GETITEMDATA, SendDlgItemMessage(hwndDlg,IDC_STATUS,CB_GETCURSEL,0,0), 0);
			j=strlen(str);
			if (send(ClientSocket, "4", 1, 0)==SOCKET_ERROR ||
				send(ClientSocket, (char *)&i, sizeof(i), 0) == SOCKET_ERROR) {
				ShowMessage(IDI_BNCERROR, "Error while sending new away-msg to server", 1);
				break;
			}
			if (i==ID_STATUS_ONLINE ||i==ID_STATUS_OFFLINE ||i==ID_STATUS_INVISIBLE) {
				j=0;
				str[0]=0;
			}
			if (send(ClientSocket, (char *)&j, sizeof(j), 0)==SOCKET_ERROR ||
				send(ClientSocket, str, strlen(str), 0)==SOCKET_ERROR) 
				ShowMessage(IDI_BNCERROR, "Error while sending new away-msg to server", 1);
			break;
	}
	return FALSE;
}

/*
 * OptionsDlgProc
 *
 * This callback function is called, when the options dialog in Miranda is shown
 * The function contains all necessary stuff to process the options in the dialog
 * and store them in the database, when changed, and fill out the settings-dialog
 * correctly according to the current settings
 */
static int CALLBACK OptionsDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	BYTE Newmode;
	const int SvrControls[]={IDC_CLIENT_IP, IDC_CLIENT_PORT, IDC_RECONNECT, IDC_RECONNECT_TOLERANCE, IDC_ALWAYSONLINE, IDC_ALWAYSONLINE_INTERVAL};
	const int CliControls[]={IDC_SERVER_IP, IDC_SERVER_PORT, IDC_CCHANGEAWAY, IDC_SYNCTIME, IDC_SYNCALLCONTACTS, IDC_SYNCONLINECONTACTS, IDC_SYNCPENDINGCONTACTS, IDC_DONTSYNCHIST, IDC_LOGHISTORY};
	int i, mode;
	static int HistorySyncMode;
	BYTE NewalwaysOnline;
	
	mode=DBGetContactSettingByte(NULL, pluginInfo.shortName, "OperationMode", 0);
	switch (uMsg){
		case WM_INITDIALOG:	
			SendMessage(hwndDlg, WM_COMMAND, mode?IDC_SERVER:IDC_CLIENT, 0);
			SetDlgItemText(hwndDlg, IDC_SERVER_IP, ServerHost);
			SetDlgItemInt(hwndDlg, IDC_SERVER_PORT, ServerPort, FALSE);
			SetDlgItemText(hwndDlg, IDC_CLIENT_IP, BindIP);
			SetDlgItemInt(hwndDlg, IDC_CLIENT_PORT, (unsigned short)DBGetContactSettingWord(NULL, pluginInfo.shortName, "BindPort", 1398), FALSE);
			CheckDlgButton(hwndDlg, IDC_RECONNECT, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "Reconnect", 0));
			SetDlgItemInt(hwndDlg, IDC_RECONNECT_TOLERANCE, (unsigned int)DBGetContactSettingDword(NULL, pluginInfo.shortName, "ReconnectTolerance", 30000), FALSE);
			CheckDlgButton(hwndDlg, IDC_ALWAYSONLINE, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "AlwaysOnline", 0));
			SetDlgItemInt(hwndDlg, IDC_ALWAYSONLINE_INTERVAL, (unsigned int)DBGetContactSettingDword(NULL, pluginInfo.shortName, "AlwaysOnlineInterval", 60000), FALSE);
			CheckDlgButton(hwndDlg, IDC_SHOWNONCRITICAL, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "ShowNonCriticalPopups", 1));
			CheckDlgButton(hwndDlg, IDC_CCHANGEAWAY, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "ChangeServerAwayMsg", 0));
			CheckDlgButton(hwndDlg, IDC_SYNCTIME, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "SyncTime", 1));
			HistorySyncMode=DBGetContactSettingDword(NULL, pluginInfo.shortName, "HistorySyncMode", IDC_DONTSYNCHIST);
			SendMessage(hwndDlg, WM_COMMAND, HistorySyncMode, 0);
			CheckDlgButton(hwndDlg, IDC_LOGHISTORY, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "LogToServer", 0));
			return TRUE;
		case WM_NOTIFY: {
			NMHDR* nmhdr = (NMHDR*)lParam;
			char buf[16];
			unsigned short tmpPort=0;

			switch (nmhdr->code){
				case PSN_APPLY:
				case PSN_KILLACTIVE:
					Newmode = SendMessage(GetDlgItem(hwndDlg, IDC_SERVER), BM_GETCHECK,0,0)==BST_CHECKED?1:0;
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "OperationMode", Newmode);
					GetDlgItemText(hwndDlg, IDC_SERVER_IP, buf, sizeof(buf));
					if (strcmp(ServerHost, buf) || ServerPort!=(tmpPort=GetDlgItemInt(hwndDlg, IDC_SERVER_PORT, NULL, FALSE))) {
						strcpy(ServerHost, buf);
						closesocket(ClientSocket);
						ClientSocket=SOCKET_ERROR;
						DBWriteContactSettingString(NULL, pluginInfo.shortName, "ServerIP", ServerHost);
						ServerPort=tmpPort;
						DBWriteContactSettingWord(NULL, pluginInfo.shortName, "ServerPort", ServerPort);
					}
					GetDlgItemText(hwndDlg, IDC_CLIENT_IP, BindIP, sizeof(BindIP));
					DBWriteContactSettingString(NULL, pluginInfo.shortName, "BindIP", BindIP);
					DBWriteContactSettingWord(NULL, pluginInfo.shortName, "BindPort", (unsigned short)GetDlgItemInt(hwndDlg, IDC_CLIENT_PORT, NULL, FALSE));
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "Reconnect", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_RECONNECT), BM_GETCHECK,0,0)));
					DBWriteContactSettingDword(NULL, pluginInfo.shortName, "ReconnectTolerance", GetDlgItemInt(hwndDlg, IDC_RECONNECT_TOLERANCE, NULL, FALSE));
					NewalwaysOnline=SendMessage(GetDlgItem(hwndDlg, IDC_ALWAYSONLINE), BM_GETCHECK,0,0)==BST_CHECKED?1:0;
					if (NewalwaysOnline!=(BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "AlwaysOnline", 0) && Newmode==mode) AlwaysOnlineCtl(NewalwaysOnline);
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "AlwaysOnline", NewalwaysOnline);
					DBWriteContactSettingDword(NULL, pluginInfo.shortName, "AlwaysOnlineInterval", GetDlgItemInt(hwndDlg, IDC_ALWAYSONLINE_INTERVAL, NULL, FALSE));
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "ShowNonCriticalPopups", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_SHOWNONCRITICAL), BM_GETCHECK,0,0)));
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "ChangeServerAwayMsg", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_CCHANGEAWAY), BM_GETCHECK,0,0)));
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "SyncTime", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_SYNCTIME), BM_GETCHECK,0,0)));
					DBWriteContactSettingDword(NULL, pluginInfo.shortName, "HistorySyncMode", HistorySyncMode);
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "LogToServer", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_LOGHISTORY), BM_GETCHECK,0,0)));
					if (Newmode!=mode)
						if (mode) { UnloadClient(); LoadServer(); }
						else { UnloadServer(); LoadClient(); }
					mode=Newmode;
					return TRUE;
			}			
			break; 
		}
		case WM_COMMAND: {
			switch (LOWORD(wParam)) {
				case IDC_SERVER:
				case IDC_CLIENT:
					CheckRadioButton(hwndDlg, IDC_SERVER, IDC_CLIENT, LOWORD( wParam ));
					for (i=0; i<sizeof(SvrControls)/sizeof(SvrControls[0]); i++) EnableWindow(GetDlgItem(hwndDlg, SvrControls[i]), LOWORD(wParam)==IDC_SERVER?TRUE:FALSE);
					for (i=0; i<sizeof(CliControls)/sizeof(CliControls[0]); i++) EnableWindow(GetDlgItem(hwndDlg, CliControls[i]), LOWORD(wParam)==IDC_SERVER?FALSE:TRUE);
					break;
				case IDC_SYNCALLCONTACTS:
				case IDC_SYNCONLINECONTACTS:
				case IDC_SYNCPENDINGCONTACTS:
				case IDC_DONTSYNCHIST:
					CheckRadioButton(hwndDlg, IDC_SYNCALLCONTACTS, IDC_DONTSYNCHIST, LOWORD(wParam));
					HistorySyncMode=LOWORD(wParam);
					break;
			}
		}
	}
	return 0;
}

/*
 * RegisterOptions
 *
 * This function tells Miranda to add the configuration section of this plugin in
 * the Options-dialog.
 */
int RegisterOptions(WPARAM wParam, LPARAM lParam) {
   OPTIONSDIALOGPAGE odp;
   
   ZeroMemory(&odp, sizeof(odp));
   odp.cbSize = sizeof(odp);
   odp.hInstance = hInst;
   odp.pszTemplate = MAKEINTRESOURCE(IDD_OPTIONS);
   odp.pszTitle = pluginInfo.shortName;
   odp.pfnDlgProc = OptionsDlgProc;
   CallService(MS_OPT_ADDPAGE, wParam, (LPARAM)&odp);
   return 0;
}

// DLL stuff

BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	hInst=hinstDLL;
	return TRUE;
}

__declspec(dllexport) PLUGININFO* MirandaPluginInfo(DWORD mirandaVersion)
{
	return &pluginInfo;
}

int __declspec(dllexport) Load(PLUGINLINK *link)	// Executed on initialisation of DLL
{
	// Allocate Resources
	DBVARIANT dbv;
	WSADATA wsaData;
	pluginLink=link;
	ZeroMemory(&BindIP, sizeof(BindIP));
	strcpy(BindIP, "0.0.0.0");
	ZeroMemory(&ServerHost, sizeof(ServerHost));

	// Read options
	if (!DBGetContactSetting(NULL, pluginInfo.shortName, "ServerIP", &dbv)) {
		CopyMemory(ServerHost, dbv.pszVal, sizeof(ServerHost));
		DBFreeVariant(&dbv);
	}
	ServerPort =DBGetContactSettingWord(NULL, pluginInfo.shortName, "ServerPort", 1398);
	if (!DBGetContactSetting(NULL, pluginInfo.shortName, "BindIP", &dbv)) {
		CopyMemory(BindIP, dbv.pszVal, sizeof(BindIP));
		DBFreeVariant(&dbv);
	}


	// Load Windows socket functions
  wsastart:
	if (WSAStartup(MAKEWORD(2,2), &wsaData) != NO_ERROR) {
		switch(MessageBox(NULL, "Error at WSAStartup() (WinSock initialisation)\nI can't work without Windows Sockets. What should I do?", pluginInfo.shortName, MB_ABORTRETRYIGNORE)) {
			case IDRETRY: goto wsastart;
			case IDABORT: hStatusHookClient = NULL; 
						  ShowMessage(IDI_BNCERROR, "Bouncer DISABLED until Miranda restart!", 1);
						  return 1;
		}
	}

	// Install Hooks
	hOptHook = HookEvent(ME_OPT_INITIALISE, RegisterOptions);
    if ((BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "OperationMode", 0)) LoadServer(); else LoadClient();
    return 0;
}

int __declspec(dllexport) Unload(void)		// Executed on DLL unload
{
	UnhookEvent(hOptHook);
	if ((BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "OperationMode", 0)) UnloadServer(); else UnloadClient();
	WSACleanup();
	return 0;
}